/* server.c generated by valac 0.20.1, the Vala compiler
 * generated from server.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2013 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <netsukuku-rpc-tcpclient.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define MONITOR_TYPE_SERVER (monitor_server_get_type ())
#define MONITOR_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MONITOR_TYPE_SERVER, MonitorServer))
#define MONITOR_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MONITOR_TYPE_SERVER, MonitorServerClass))
#define MONITOR_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MONITOR_TYPE_SERVER))
#define MONITOR_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MONITOR_TYPE_SERVER))
#define MONITOR_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MONITOR_TYPE_SERVER, MonitorServerClass))

typedef struct _MonitorServer MonitorServer;
typedef struct _MonitorServerClass MonitorServerClass;
typedef struct _MonitorServerPrivate MonitorServerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MonitorServer {
	GObject parent_instance;
	MonitorServerPrivate * priv;
};

struct _MonitorServerClass {
	GObjectClass parent_class;
};

struct _MonitorServerPrivate {
	GtkWindow* _win_server;
	GtkWidget* _widget_root;
	NetsukukuAndnaPrivateConfigurationServer* server;
	GtkButton* but_retrieve_pubk;
	NetsukukuPublicKey* server_pubk;
	GtkRadioButton* radio_alias;
	GtkRadioButton* radio_myself;
	GtkEntry* _txt_alias;
	GtkEntry* _txt_name_for_pubk;
	GtkLabel* _lbl_display_pubk;
	GtkSpinButton* _txt_prio;
	GtkSpinButton* _txt_weight;
	GtkSpinButton* _txt_port;
	GtkLabel* _lbl_name;
	GtkLabel* _lbl_servicekey;
};

typedef NetsukukuPublicKey* (*MonitorRetrievePubkDelegate) (const gchar* domain, void* user_data);

static gpointer monitor_server_parent_class = NULL;
extern MonitorRetrievePubkDelegate monitor_retrieve_pubk;
extern gpointer monitor_retrieve_pubk_target;
extern GDestroyNotify monitor_retrieve_pubk_target_destroy_notify;

GType monitor_server_get_type (void) G_GNUC_CONST;
#define MONITOR_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MONITOR_TYPE_SERVER, MonitorServerPrivate))
enum  {
	MONITOR_SERVER_DUMMY_PROPERTY,
	MONITOR_SERVER_WIN_SERVER,
	MONITOR_SERVER_WIDGET_ROOT,
	MONITOR_SERVER_TXT_ALIAS,
	MONITOR_SERVER_TXT_NAME_FOR_PUBK,
	MONITOR_SERVER_LBL_DISPLAY_PUBK,
	MONITOR_SERVER_TXT_PRIO,
	MONITOR_SERVER_TXT_WEIGHT,
	MONITOR_SERVER_TXT_PORT,
	MONITOR_SERVER_LBL_NAME,
	MONITOR_SERVER_LBL_SERVICEKEY
};
MonitorServer* monitor_server_new (NetsukukuAndnaPrivateConfigurationServer* server, const gchar* name, const gchar* servicekey);
MonitorServer* monitor_server_construct (GType object_type, NetsukukuAndnaPrivateConfigurationServer* server, const gchar* name, const gchar* servicekey);
static void monitor_server_set_win_server (MonitorServer* self, GtkWindow* value);
static void monitor_server_set_widget_root (MonitorServer* self, GtkWidget* value);
static void monitor_server_set_lbl_name (MonitorServer* self, GtkLabel* value);
GtkLabel* monitor_server_get_lbl_name (MonitorServer* self);
static void monitor_server_set_lbl_servicekey (MonitorServer* self, GtkLabel* value);
GtkLabel* monitor_server_get_lbl_servicekey (MonitorServer* self);
static void monitor_server_set_txt_alias (MonitorServer* self, GtkEntry* value);
static void monitor_server_set_txt_name_for_pubk (MonitorServer* self, GtkEntry* value);
static void monitor_server_set_lbl_display_pubk (MonitorServer* self, GtkLabel* value);
static void monitor_server_set_txt_prio (MonitorServer* self, GtkSpinButton* value);
static void monitor_server_set_txt_weight (MonitorServer* self, GtkSpinButton* value);
static void monitor_server_set_txt_port (MonitorServer* self, GtkSpinButton* value);
GtkWindow* monitor_server_get_win_server (MonitorServer* self);
static void monitor_server_going_back (MonitorServer* self);
static void _monitor_server_going_back_gtk_widget_destroy (GtkWidget* _sender, gpointer self);
void monitor_server_set_ui (MonitorServer* self, NetsukukuAndnaPrivateConfigurationServer* rec);
void monitor_server_radio_alias_toggled (GtkRadioButton* source, MonitorServer* self);
void monitor_server_set_ui_radio (MonitorServer* self);
GtkEntry* monitor_server_get_txt_alias (MonitorServer* self);
GtkSpinButton* monitor_server_get_txt_port (MonitorServer* self);
GtkSpinButton* monitor_server_get_txt_prio (MonitorServer* self);
GtkSpinButton* monitor_server_get_txt_weight (MonitorServer* self);
void monitor_server_retrieve_pubk_clicked (GtkButton* source, MonitorServer* self);
GtkEntry* monitor_server_get_txt_name_for_pubk (MonitorServer* self);
void monitor_server_set_ui_pubk (MonitorServer* self, NetsukukuPublicKey* pk);
GtkLabel* monitor_server_get_lbl_display_pubk (MonitorServer* self);
GtkWidget* monitor_server_get_widget_root (MonitorServer* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void monitor_server_finalize (GObject* obj);
static void _vala_monitor_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_monitor_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _monitor_server_going_back_gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
	monitor_server_going_back (self);
}


MonitorServer* monitor_server_construct (GType object_type, NetsukukuAndnaPrivateConfigurationServer* server, const gchar* name, const gchar* servicekey) {
	MonitorServer * self = NULL;
	NetsukukuAndnaPrivateConfigurationServer* _tmp0_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp1_;
	GtkBuilder* _tmp2_;
	GtkBuilder* builder;
	GObject* _tmp3_ = NULL;
	GObject* _tmp4_ = NULL;
	GObject* _tmp5_ = NULL;
	GtkLabel* _tmp6_;
	const gchar* _tmp7_;
	GObject* _tmp8_ = NULL;
	GtkLabel* _tmp9_;
	const gchar* _tmp10_;
	GObject* _tmp11_ = NULL;
	GtkRadioButton* _tmp12_;
	GObject* _tmp13_ = NULL;
	GtkRadioButton* _tmp14_;
	GObject* _tmp15_ = NULL;
	GObject* _tmp16_ = NULL;
	GObject* _tmp17_ = NULL;
	GtkButton* _tmp18_;
	GObject* _tmp19_ = NULL;
	GObject* _tmp20_ = NULL;
	GObject* _tmp21_ = NULL;
	GObject* _tmp22_ = NULL;
	GtkWindow* _tmp23_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp24_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (server != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (servicekey != NULL, NULL);
	self = (MonitorServer*) g_object_new (object_type, NULL);
	_tmp0_ = server;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->server);
	self->priv->server = _tmp1_;
	_tmp2_ = gtk_builder_new ();
	builder = _tmp2_;
	gtk_builder_add_from_resource (builder, "/org/netsukuku/monitorradar/server.ui", &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_builder_connect_signals (builder, self);
	_tmp3_ = gtk_builder_get_object (builder, "win_server");
	monitor_server_set_win_server (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp3_) : NULL);
	_tmp4_ = gtk_builder_get_object (builder, "widget_root");
	monitor_server_set_widget_root (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GTK_TYPE_WIDGET) ? ((GtkWidget*) _tmp4_) : NULL);
	_tmp5_ = gtk_builder_get_object (builder, "lbl_name");
	monitor_server_set_lbl_name (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, GTK_TYPE_LABEL) ? ((GtkLabel*) _tmp5_) : NULL);
	_tmp6_ = self->priv->_lbl_name;
	_tmp7_ = name;
	gtk_label_set_label (_tmp6_, _tmp7_);
	_tmp8_ = gtk_builder_get_object (builder, "lbl_servicekey");
	monitor_server_set_lbl_servicekey (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GTK_TYPE_LABEL) ? ((GtkLabel*) _tmp8_) : NULL);
	_tmp9_ = self->priv->_lbl_servicekey;
	_tmp10_ = servicekey;
	gtk_label_set_label (_tmp9_, _tmp10_);
	_tmp11_ = gtk_builder_get_object (builder, "radio_alias");
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, GTK_TYPE_RADIO_BUTTON) ? ((GtkRadioButton*) _tmp11_) : NULL);
	_g_object_unref0 (self->priv->radio_alias);
	self->priv->radio_alias = _tmp12_;
	_tmp13_ = gtk_builder_get_object (builder, "radio_myself");
	_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GTK_TYPE_RADIO_BUTTON) ? ((GtkRadioButton*) _tmp13_) : NULL);
	_g_object_unref0 (self->priv->radio_myself);
	self->priv->radio_myself = _tmp14_;
	_tmp15_ = gtk_builder_get_object (builder, "txt_alias");
	monitor_server_set_txt_alias (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp15_) : NULL);
	_tmp16_ = gtk_builder_get_object (builder, "txt_name_for_pubk");
	monitor_server_set_txt_name_for_pubk (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp16_) : NULL);
	_tmp17_ = gtk_builder_get_object (builder, "but_retrieve_pubk");
	_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, GTK_TYPE_BUTTON) ? ((GtkButton*) _tmp17_) : NULL);
	_g_object_unref0 (self->priv->but_retrieve_pubk);
	self->priv->but_retrieve_pubk = _tmp18_;
	_tmp19_ = gtk_builder_get_object (builder, "lbl_display_pubk");
	monitor_server_set_lbl_display_pubk (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, GTK_TYPE_LABEL) ? ((GtkLabel*) _tmp19_) : NULL);
	_tmp20_ = gtk_builder_get_object (builder, "txt_prio");
	monitor_server_set_txt_prio (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, GTK_TYPE_SPIN_BUTTON) ? ((GtkSpinButton*) _tmp20_) : NULL);
	_tmp21_ = gtk_builder_get_object (builder, "txt_weight");
	monitor_server_set_txt_weight (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GTK_TYPE_SPIN_BUTTON) ? ((GtkSpinButton*) _tmp21_) : NULL);
	_tmp22_ = gtk_builder_get_object (builder, "txt_port");
	monitor_server_set_txt_port (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, GTK_TYPE_SPIN_BUTTON) ? ((GtkSpinButton*) _tmp22_) : NULL);
	_tmp23_ = self->priv->_win_server;
	g_signal_connect_object ((GtkWidget*) _tmp23_, "destroy", (GCallback) _monitor_server_going_back_gtk_widget_destroy, self, 0);
	_tmp24_ = server;
	monitor_server_set_ui (self, _tmp24_);
	_g_object_unref0 (builder);
	return self;
}


MonitorServer* monitor_server_new (NetsukukuAndnaPrivateConfigurationServer* server, const gchar* name, const gchar* servicekey) {
	return monitor_server_construct (MONITOR_TYPE_SERVER, server, name, servicekey);
}


void monitor_server_radio_alias_toggled (GtkRadioButton* source, MonitorServer* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	monitor_server_set_ui_radio (self);
}


static void monitor_server_going_back (MonitorServer* self) {
	NetsukukuAndnaPrivateConfigurationServer* recnew = NULL;
	gchar* alias;
	NetsukukuPublicKey* pubk;
	gint port_number = 0;
	gint priority = 0;
	gint weight = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkSpinButton* _tmp9_;
	gint _tmp10_ = 0;
	GtkSpinButton* _tmp11_;
	gint _tmp12_ = 0;
	GtkSpinButton* _tmp13_;
	gint _tmp14_ = 0;
	const gchar* _tmp15_;
	NetsukukuPublicKey* _tmp16_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp17_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp18_;
	g_return_if_fail (self != NULL);
	alias = NULL;
	pubk = NULL;
	_tmp0_ = self->priv->radio_alias;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		NetsukukuPublicKey* _tmp7_;
		NetsukukuPublicKey* _tmp8_;
		_tmp3_ = self->priv->_txt_alias;
		_tmp4_ = gtk_entry_get_text (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (alias);
		alias = _tmp6_;
		_tmp7_ = self->priv->server_pubk;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_g_object_unref0 (pubk);
		pubk = _tmp8_;
	}
	_tmp9_ = self->priv->_txt_port;
	_tmp10_ = gtk_spin_button_get_value_as_int (_tmp9_);
	port_number = _tmp10_;
	_tmp11_ = self->priv->_txt_prio;
	_tmp12_ = gtk_spin_button_get_value_as_int (_tmp11_);
	priority = _tmp12_;
	_tmp13_ = self->priv->_txt_weight;
	_tmp14_ = gtk_spin_button_get_value_as_int (_tmp13_);
	weight = _tmp14_;
	_tmp15_ = alias;
	_tmp16_ = pubk;
	_tmp17_ = netsukuku_andna_private_configuration_server_new (_tmp15_, _tmp16_, port_number, priority, weight);
	_g_object_unref0 (recnew);
	recnew = _tmp17_;
	_tmp18_ = self->priv->server;
	g_signal_emit_by_name (self, "go-back", _tmp18_, recnew);
	_g_object_unref0 (pubk);
	_g_free0 (alias);
	_g_object_unref0 (recnew);
}


void monitor_server_retrieve_pubk_clicked (GtkButton* source, MonitorServer* self) {
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* name_for_pubk;
	MonitorRetrievePubkDelegate _tmp4_;
	void* _tmp4__target;
	NetsukukuPublicKey* _tmp5_ = NULL;
	NetsukukuPublicKey* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->_txt_name_for_pubk;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	name_for_pubk = _tmp3_;
	_tmp4_ = monitor_retrieve_pubk;
	_tmp4__target = monitor_retrieve_pubk_target;
	_tmp5_ = _tmp4_ (name_for_pubk, _tmp4__target);
	_tmp6_ = _tmp5_;
	monitor_server_set_ui_pubk (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_g_free0 (name_for_pubk);
}


void monitor_server_set_ui (MonitorServer* self, NetsukukuAndnaPrivateConfigurationServer* rec) {
	NetsukukuAndnaPrivateConfigurationServer* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkSpinButton* _tmp9_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkSpinButton* _tmp13_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GtkSpinButton* _tmp17_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	NetsukukuAndnaPrivateConfigurationServer* _tmp21_;
	NetsukukuPublicKey* _tmp22_;
	NetsukukuPublicKey* _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (rec != NULL);
	_tmp0_ = rec;
	_tmp1_ = netsukuku_andna_private_configuration_server_get_alias (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		GtkRadioButton* _tmp3_;
		_tmp3_ = self->priv->radio_myself;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
	} else {
		GtkRadioButton* _tmp4_;
		GtkEntry* _tmp5_;
		NetsukukuAndnaPrivateConfigurationServer* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp4_ = self->priv->radio_alias;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, TRUE);
		_tmp5_ = self->priv->_txt_alias;
		_tmp6_ = rec;
		_tmp7_ = netsukuku_andna_private_configuration_server_get_alias (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_entry_set_text (_tmp5_, _tmp8_);
	}
	_tmp9_ = self->priv->_txt_port;
	_tmp10_ = rec;
	_tmp11_ = netsukuku_andna_private_configuration_server_get_port_number (_tmp10_);
	_tmp12_ = _tmp11_;
	gtk_spin_button_set_value (_tmp9_, (gdouble) _tmp12_);
	_tmp13_ = self->priv->_txt_prio;
	_tmp14_ = rec;
	_tmp15_ = netsukuku_andna_private_configuration_server_get_priority (_tmp14_);
	_tmp16_ = _tmp15_;
	gtk_spin_button_set_value (_tmp13_, (gdouble) _tmp16_);
	_tmp17_ = self->priv->_txt_weight;
	_tmp18_ = rec;
	_tmp19_ = netsukuku_andna_private_configuration_server_get_weight (_tmp18_);
	_tmp20_ = _tmp19_;
	gtk_spin_button_set_value (_tmp17_, (gdouble) _tmp20_);
	_tmp21_ = rec;
	_tmp22_ = netsukuku_andna_private_configuration_server_get_pubk (_tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == NULL) {
		GtkLabel* _tmp24_;
		NetsukukuAndnaPrivateConfigurationServer* _tmp25_;
		NetsukukuPublicKey* _tmp26_;
		NetsukukuPublicKey* _tmp27_;
		NetsukukuPublicKey* _tmp28_;
		_tmp24_ = self->priv->_lbl_display_pubk;
		gtk_label_set_label (_tmp24_, "NULL");
		_tmp25_ = rec;
		_tmp26_ = netsukuku_andna_private_configuration_server_get_pubk (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = _g_object_ref0 (_tmp27_);
		_g_object_unref0 (self->priv->server_pubk);
		self->priv->server_pubk = _tmp28_;
	} else {
		GtkLabel* _tmp29_;
		NetsukukuAndnaPrivateConfigurationServer* _tmp30_;
		NetsukukuPublicKey* _tmp31_;
		NetsukukuPublicKey* _tmp32_;
		gchar* _tmp33_ = NULL;
		gchar* _tmp34_;
		NetsukukuAndnaPrivateConfigurationServer* _tmp35_;
		NetsukukuPublicKey* _tmp36_;
		NetsukukuPublicKey* _tmp37_;
		NetsukukuPublicKey* _tmp38_;
		_tmp29_ = self->priv->_lbl_display_pubk;
		_tmp30_ = rec;
		_tmp31_ = netsukuku_andna_private_configuration_server_get_pubk (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = netsukuku_public_key_to_string (_tmp32_);
		_tmp34_ = _tmp33_;
		gtk_label_set_label (_tmp29_, _tmp34_);
		_g_free0 (_tmp34_);
		_tmp35_ = rec;
		_tmp36_ = netsukuku_andna_private_configuration_server_get_pubk (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = _g_object_ref0 (_tmp37_);
		_g_object_unref0 (self->priv->server_pubk);
		self->priv->server_pubk = _tmp38_;
	}
	monitor_server_set_ui_radio (self);
}


void monitor_server_set_ui_pubk (MonitorServer* self, NetsukukuPublicKey* pk) {
	NetsukukuPublicKey* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pk;
	if (_tmp0_ == NULL) {
		GtkLabel* _tmp1_;
		NetsukukuPublicKey* _tmp2_;
		NetsukukuPublicKey* _tmp3_;
		_tmp1_ = self->priv->_lbl_display_pubk;
		gtk_label_set_label (_tmp1_, "NULL");
		_tmp2_ = pk;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_g_object_unref0 (self->priv->server_pubk);
		self->priv->server_pubk = _tmp3_;
	} else {
		GtkLabel* _tmp4_;
		NetsukukuPublicKey* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		NetsukukuPublicKey* _tmp8_;
		NetsukukuPublicKey* _tmp9_;
		_tmp4_ = self->priv->_lbl_display_pubk;
		_tmp5_ = pk;
		_tmp6_ = netsukuku_public_key_to_string (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_label_set_label (_tmp4_, _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = pk;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (self->priv->server_pubk);
		self->priv->server_pubk = _tmp9_;
	}
}


void monitor_server_set_ui_radio (MonitorServer* self) {
	GtkEntry* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkEntry* _tmp4_;
	GtkRadioButton* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkButton* _tmp8_;
	GtkRadioButton* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_txt_alias;
	_tmp1_ = self->priv->radio_alias;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp3_);
	_tmp4_ = self->priv->_txt_name_for_pubk;
	_tmp5_ = self->priv->radio_alias;
	_tmp6_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_);
	_tmp7_ = _tmp6_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp7_);
	_tmp8_ = self->priv->but_retrieve_pubk;
	_tmp9_ = self->priv->radio_alias;
	_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, _tmp11_);
}


GtkWindow* monitor_server_get_win_server (MonitorServer* self) {
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_win_server;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_win_server (MonitorServer* self, GtkWindow* value) {
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_win_server);
	self->priv->_win_server = _tmp1_;
	g_object_notify ((GObject *) self, "win-server");
}


GtkWidget* monitor_server_get_widget_root (MonitorServer* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_widget_root;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_widget_root (MonitorServer* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_widget_root);
	self->priv->_widget_root = _tmp1_;
	g_object_notify ((GObject *) self, "widget-root");
}


GtkEntry* monitor_server_get_txt_alias (MonitorServer* self) {
	GtkEntry* result;
	GtkEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_alias;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_txt_alias (MonitorServer* self, GtkEntry* value) {
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_alias);
	self->priv->_txt_alias = _tmp1_;
	g_object_notify ((GObject *) self, "txt-alias");
}


GtkEntry* monitor_server_get_txt_name_for_pubk (MonitorServer* self) {
	GtkEntry* result;
	GtkEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_name_for_pubk;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_txt_name_for_pubk (MonitorServer* self, GtkEntry* value) {
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_name_for_pubk);
	self->priv->_txt_name_for_pubk = _tmp1_;
	g_object_notify ((GObject *) self, "txt-name-for-pubk");
}


GtkLabel* monitor_server_get_lbl_display_pubk (MonitorServer* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lbl_display_pubk;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_lbl_display_pubk (MonitorServer* self, GtkLabel* value) {
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_lbl_display_pubk);
	self->priv->_lbl_display_pubk = _tmp1_;
	g_object_notify ((GObject *) self, "lbl-display-pubk");
}


GtkSpinButton* monitor_server_get_txt_prio (MonitorServer* self) {
	GtkSpinButton* result;
	GtkSpinButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_prio;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_txt_prio (MonitorServer* self, GtkSpinButton* value) {
	GtkSpinButton* _tmp0_;
	GtkSpinButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_prio);
	self->priv->_txt_prio = _tmp1_;
	g_object_notify ((GObject *) self, "txt-prio");
}


GtkSpinButton* monitor_server_get_txt_weight (MonitorServer* self) {
	GtkSpinButton* result;
	GtkSpinButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_weight;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_txt_weight (MonitorServer* self, GtkSpinButton* value) {
	GtkSpinButton* _tmp0_;
	GtkSpinButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_weight);
	self->priv->_txt_weight = _tmp1_;
	g_object_notify ((GObject *) self, "txt-weight");
}


GtkSpinButton* monitor_server_get_txt_port (MonitorServer* self) {
	GtkSpinButton* result;
	GtkSpinButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_port;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_txt_port (MonitorServer* self, GtkSpinButton* value) {
	GtkSpinButton* _tmp0_;
	GtkSpinButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_port);
	self->priv->_txt_port = _tmp1_;
	g_object_notify ((GObject *) self, "txt-port");
}


GtkLabel* monitor_server_get_lbl_name (MonitorServer* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lbl_name;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_lbl_name (MonitorServer* self, GtkLabel* value) {
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_lbl_name);
	self->priv->_lbl_name = _tmp1_;
	g_object_notify ((GObject *) self, "lbl-name");
}


GtkLabel* monitor_server_get_lbl_servicekey (MonitorServer* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lbl_servicekey;
	result = _tmp0_;
	return result;
}


static void monitor_server_set_lbl_servicekey (MonitorServer* self, GtkLabel* value) {
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_lbl_servicekey);
	self->priv->_lbl_servicekey = _tmp1_;
	g_object_notify ((GObject *) self, "lbl-servicekey");
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void monitor_server_class_init (MonitorServerClass * klass) {
	monitor_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MonitorServerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_monitor_server_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_monitor_server_set_property;
	G_OBJECT_CLASS (klass)->finalize = monitor_server_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_WIN_SERVER, g_param_spec_object ("win-server", "win-server", "win-server", GTK_TYPE_WINDOW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_WIDGET_ROOT, g_param_spec_object ("widget-root", "widget-root", "widget-root", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_TXT_ALIAS, g_param_spec_object ("txt-alias", "txt-alias", "txt-alias", GTK_TYPE_ENTRY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_TXT_NAME_FOR_PUBK, g_param_spec_object ("txt-name-for-pubk", "txt-name-for-pubk", "txt-name-for-pubk", GTK_TYPE_ENTRY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_LBL_DISPLAY_PUBK, g_param_spec_object ("lbl-display-pubk", "lbl-display-pubk", "lbl-display-pubk", GTK_TYPE_LABEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_TXT_PRIO, g_param_spec_object ("txt-prio", "txt-prio", "txt-prio", GTK_TYPE_SPIN_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_TXT_WEIGHT, g_param_spec_object ("txt-weight", "txt-weight", "txt-weight", GTK_TYPE_SPIN_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_TXT_PORT, g_param_spec_object ("txt-port", "txt-port", "txt-port", GTK_TYPE_SPIN_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_LBL_NAME, g_param_spec_object ("lbl-name", "lbl-name", "lbl-name", GTK_TYPE_LABEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVER_LBL_SERVICEKEY, g_param_spec_object ("lbl-servicekey", "lbl-servicekey", "lbl-servicekey", GTK_TYPE_LABEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("go_back", MONITOR_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, NETSUKUKU_TYPE_ANDNA_PRIVATE_CONFIGURATION_SERVER, NETSUKUKU_TYPE_ANDNA_PRIVATE_CONFIGURATION_SERVER);
}


static void monitor_server_instance_init (MonitorServer * self) {
	self->priv = MONITOR_SERVER_GET_PRIVATE (self);
}


static void monitor_server_finalize (GObject* obj) {
	MonitorServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MONITOR_TYPE_SERVER, MonitorServer);
	_g_object_unref0 (self->priv->_win_server);
	_g_object_unref0 (self->priv->_widget_root);
	_g_object_unref0 (self->priv->server);
	_g_object_unref0 (self->priv->but_retrieve_pubk);
	_g_object_unref0 (self->priv->server_pubk);
	_g_object_unref0 (self->priv->radio_alias);
	_g_object_unref0 (self->priv->radio_myself);
	_g_object_unref0 (self->priv->_txt_alias);
	_g_object_unref0 (self->priv->_txt_name_for_pubk);
	_g_object_unref0 (self->priv->_lbl_display_pubk);
	_g_object_unref0 (self->priv->_txt_prio);
	_g_object_unref0 (self->priv->_txt_weight);
	_g_object_unref0 (self->priv->_txt_port);
	_g_object_unref0 (self->priv->_lbl_name);
	_g_object_unref0 (self->priv->_lbl_servicekey);
	G_OBJECT_CLASS (monitor_server_parent_class)->finalize (obj);
}


GType monitor_server_get_type (void) {
	static volatile gsize monitor_server_type_id__volatile = 0;
	if (g_once_init_enter (&monitor_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MonitorServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitor_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MonitorServer), 0, (GInstanceInitFunc) monitor_server_instance_init, NULL };
		GType monitor_server_type_id;
		monitor_server_type_id = g_type_register_static (G_TYPE_OBJECT, "MonitorServer", &g_define_type_info, 0);
		g_once_init_leave (&monitor_server_type_id__volatile, monitor_server_type_id);
	}
	return monitor_server_type_id__volatile;
}


static void _vala_monitor_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MonitorServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MONITOR_TYPE_SERVER, MonitorServer);
	switch (property_id) {
		case MONITOR_SERVER_WIN_SERVER:
		g_value_set_object (value, monitor_server_get_win_server (self));
		break;
		case MONITOR_SERVER_WIDGET_ROOT:
		g_value_set_object (value, monitor_server_get_widget_root (self));
		break;
		case MONITOR_SERVER_TXT_ALIAS:
		g_value_set_object (value, monitor_server_get_txt_alias (self));
		break;
		case MONITOR_SERVER_TXT_NAME_FOR_PUBK:
		g_value_set_object (value, monitor_server_get_txt_name_for_pubk (self));
		break;
		case MONITOR_SERVER_LBL_DISPLAY_PUBK:
		g_value_set_object (value, monitor_server_get_lbl_display_pubk (self));
		break;
		case MONITOR_SERVER_TXT_PRIO:
		g_value_set_object (value, monitor_server_get_txt_prio (self));
		break;
		case MONITOR_SERVER_TXT_WEIGHT:
		g_value_set_object (value, monitor_server_get_txt_weight (self));
		break;
		case MONITOR_SERVER_TXT_PORT:
		g_value_set_object (value, monitor_server_get_txt_port (self));
		break;
		case MONITOR_SERVER_LBL_NAME:
		g_value_set_object (value, monitor_server_get_lbl_name (self));
		break;
		case MONITOR_SERVER_LBL_SERVICEKEY:
		g_value_set_object (value, monitor_server_get_lbl_servicekey (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_monitor_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MonitorServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MONITOR_TYPE_SERVER, MonitorServer);
	switch (property_id) {
		case MONITOR_SERVER_WIN_SERVER:
		monitor_server_set_win_server (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_WIDGET_ROOT:
		monitor_server_set_widget_root (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_TXT_ALIAS:
		monitor_server_set_txt_alias (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_TXT_NAME_FOR_PUBK:
		monitor_server_set_txt_name_for_pubk (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_LBL_DISPLAY_PUBK:
		monitor_server_set_lbl_display_pubk (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_TXT_PRIO:
		monitor_server_set_txt_prio (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_TXT_WEIGHT:
		monitor_server_set_txt_weight (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_TXT_PORT:
		monitor_server_set_txt_port (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_LBL_NAME:
		monitor_server_set_lbl_name (self, g_value_get_object (value));
		break;
		case MONITOR_SERVER_LBL_SERVICEKEY:
		monitor_server_set_lbl_servicekey (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



