/* services.c generated by valac 0.20.1, the Vala compiler
 * generated from services.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2013 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <netsukuku-rpc-tcpclient.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define MONITOR_TYPE_LISTSERVICES (monitor_listservices_get_type ())

#define MONITOR_TYPE_SERVICES (monitor_services_get_type ())
#define MONITOR_SERVICES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MONITOR_TYPE_SERVICES, MonitorServices))
#define MONITOR_SERVICES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MONITOR_TYPE_SERVICES, MonitorServicesClass))
#define MONITOR_IS_SERVICES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MONITOR_TYPE_SERVICES))
#define MONITOR_IS_SERVICES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MONITOR_TYPE_SERVICES))
#define MONITOR_SERVICES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MONITOR_TYPE_SERVICES, MonitorServicesClass))

typedef struct _MonitorServices MonitorServices;
typedef struct _MonitorServicesClass MonitorServicesClass;
typedef struct _MonitorServicesPrivate MonitorServicesPrivate;

#define MONITOR_TYPE_SERVERS (monitor_servers_get_type ())
#define MONITOR_SERVERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MONITOR_TYPE_SERVERS, MonitorServers))
#define MONITOR_SERVERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MONITOR_TYPE_SERVERS, MonitorServersClass))
#define MONITOR_IS_SERVERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MONITOR_TYPE_SERVERS))
#define MONITOR_IS_SERVERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MONITOR_TYPE_SERVERS))
#define MONITOR_SERVERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MONITOR_TYPE_SERVERS, MonitorServersClass))

typedef struct _MonitorServers MonitorServers;
typedef struct _MonitorServersClass MonitorServersClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

typedef enum  {
	MONITOR_LISTSERVICES_STR_REPR,
	MONITOR_LISTSERVICES_SERVICE_KEY,
	MONITOR_LISTSERVICES_NUMCOLUMNS
} MonitorLISTSERVICES;

struct _MonitorServices {
	GObject parent_instance;
	MonitorServicesPrivate * priv;
};

struct _MonitorServicesClass {
	GObjectClass parent_class;
};

struct _MonitorServicesPrivate {
	GtkWindow* _win_services;
	GtkWidget* _widget_root;
	NetsukukuAndnaPrivateConfiguration* root;
	gchar* name;
	GtkListStore* liststore_services;
	GtkTreeView* tv_services;
	GtkButton* but_add;
	GtkButton* but_remove;
	GtkButton* but_details;
	GtkEntry* _txt_name;
	MonitorServers* servers;
	NetsukukuAndnaServiceKey* selected_key;
};


static gpointer monitor_services_parent_class = NULL;

GType monitor_listservices_get_type (void) G_GNUC_CONST;
GType monitor_services_get_type (void) G_GNUC_CONST;
GType monitor_servers_get_type (void) G_GNUC_CONST;
#define MONITOR_SERVICES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MONITOR_TYPE_SERVICES, MonitorServicesPrivate))
enum  {
	MONITOR_SERVICES_DUMMY_PROPERTY,
	MONITOR_SERVICES_WIN_SERVICES,
	MONITOR_SERVICES_WIDGET_ROOT,
	MONITOR_SERVICES_TXT_NAME
};
MonitorServices* monitor_services_new (NetsukukuAndnaPrivateConfiguration* root);
MonitorServices* monitor_services_construct (GType object_type, NetsukukuAndnaPrivateConfiguration* root);
static void monitor_services_set_win_services (MonitorServices* self, GtkWindow* value);
static void monitor_services_set_widget_root (MonitorServices* self, GtkWidget* value);
static void monitor_services_set_txt_name (MonitorServices* self, GtkEntry* value);
GtkEntry* monitor_services_get_txt_name (MonitorServices* self);
GtkWindow* monitor_services_get_win_services (MonitorServices* self);
static void monitor_services_going_back (MonitorServices* self);
static void _monitor_services_going_back_gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void __lambda21_ (MonitorServices* self);
static void monitor_services_tv_services_selection_changed (MonitorServices* self);
static void ___lambda21__gtk_tree_selection_changed (GtkTreeSelection* _sender, gpointer self);
void monitor_services_refresh (MonitorServices* self);
void monitor_services_add_service_clicked (GtkButton* source, MonitorServices* self);
static void monitor_services_add_service (MonitorServices* self);
void monitor_services_remove_service_clicked (GtkButton* source, MonitorServices* self);
void monitor_services_details_service_clicked (GtkButton* source, MonitorServices* self);
MonitorServers* monitor_servers_new (GeeHashMap* services, NetsukukuAndnaServiceKey* servicekey, const gchar* name);
MonitorServers* monitor_servers_construct (GType object_type, GeeHashMap* services, NetsukukuAndnaServiceKey* servicekey, const gchar* name);
GtkWindow* monitor_servers_get_win_servers (MonitorServers* self);
void monitor_services_update (MonitorServices* self);
static void _monitor_services_update_monitor_servers_go_back (MonitorServers* _sender, gpointer self);
GtkWidget* monitor_services_get_widget_root (MonitorServices* self);
static void monitor_services_finalize (GObject* obj);
static void _vala_monitor_services_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_monitor_services_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType monitor_listservices_get_type (void) {
	static volatile gsize monitor_listservices_type_id__volatile = 0;
	if (g_once_init_enter (&monitor_listservices_type_id__volatile)) {
		static const GEnumValue values[] = {{MONITOR_LISTSERVICES_STR_REPR, "MONITOR_LISTSERVICES_STR_REPR", "str-repr"}, {MONITOR_LISTSERVICES_SERVICE_KEY, "MONITOR_LISTSERVICES_SERVICE_KEY", "service-key"}, {MONITOR_LISTSERVICES_NUMCOLUMNS, "MONITOR_LISTSERVICES_NUMCOLUMNS", "numcolumns"}, {0, NULL, NULL}};
		GType monitor_listservices_type_id;
		monitor_listservices_type_id = g_enum_register_static ("MonitorLISTSERVICES", values);
		g_once_init_leave (&monitor_listservices_type_id__volatile, monitor_listservices_type_id);
	}
	return monitor_listservices_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _monitor_services_going_back_gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
	monitor_services_going_back (self);
}


static void __lambda21_ (MonitorServices* self) {
	monitor_services_tv_services_selection_changed (self);
}


static void ___lambda21__gtk_tree_selection_changed (GtkTreeSelection* _sender, gpointer self) {
	__lambda21_ (self);
}


MonitorServices* monitor_services_construct (GType object_type, NetsukukuAndnaPrivateConfiguration* root) {
	MonitorServices * self = NULL;
	NetsukukuAndnaPrivateConfiguration* _tmp0_;
	NetsukukuAndnaPrivateConfiguration* _tmp1_;
	NetsukukuAndnaPrivateConfiguration* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GtkBuilder* _tmp5_;
	GtkBuilder* builder;
	GObject* _tmp6_ = NULL;
	GObject* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GtkListStore* _tmp9_;
	GObject* _tmp10_ = NULL;
	GtkTreeView* _tmp11_;
	GObject* _tmp12_ = NULL;
	GtkButton* _tmp13_;
	GObject* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GObject* _tmp16_ = NULL;
	GtkButton* _tmp17_;
	GObject* _tmp18_ = NULL;
	GtkEntry* _tmp19_;
	const gchar* _tmp20_;
	GtkWindow* _tmp21_;
	GtkTreeView* _tmp22_;
	GtkTreeSelection* _tmp23_ = NULL;
	GtkTreeSelection* _tmp24_;
	GtkTreeSelection* sel_services;
	GtkTreeSelection* _tmp25_;
	GtkTreeSelection* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (root != NULL, NULL);
	self = (MonitorServices*) g_object_new (object_type, NULL);
	_tmp0_ = root;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->root);
	self->priv->root = _tmp1_;
	_tmp2_ = root;
	_tmp3_ = _tmp2_->domain;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp4_;
	_tmp5_ = gtk_builder_new ();
	builder = _tmp5_;
	gtk_builder_add_from_resource (builder, "/org/netsukuku/monitorradar/services.ui", &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_builder_connect_signals (builder, self);
	_tmp6_ = gtk_builder_get_object (builder, "win_services");
	monitor_services_set_win_services (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp6_) : NULL);
	_tmp7_ = gtk_builder_get_object (builder, "widget_root");
	monitor_services_set_widget_root (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, GTK_TYPE_WIDGET) ? ((GtkWidget*) _tmp7_) : NULL);
	_tmp8_ = gtk_builder_get_object (builder, "liststore_services");
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GTK_TYPE_LIST_STORE) ? ((GtkListStore*) _tmp8_) : NULL);
	_g_object_unref0 (self->priv->liststore_services);
	self->priv->liststore_services = _tmp9_;
	_tmp10_ = gtk_builder_get_object (builder, "tv_services");
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, GTK_TYPE_TREE_VIEW) ? ((GtkTreeView*) _tmp10_) : NULL);
	_g_object_unref0 (self->priv->tv_services);
	self->priv->tv_services = _tmp11_;
	_tmp12_ = gtk_builder_get_object (builder, "but_add");
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, GTK_TYPE_BUTTON) ? ((GtkButton*) _tmp12_) : NULL);
	_g_object_unref0 (self->priv->but_add);
	self->priv->but_add = _tmp13_;
	_tmp14_ = gtk_builder_get_object (builder, "but_remove");
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GTK_TYPE_BUTTON) ? ((GtkButton*) _tmp14_) : NULL);
	_g_object_unref0 (self->priv->but_remove);
	self->priv->but_remove = _tmp15_;
	_tmp16_ = gtk_builder_get_object (builder, "but_details");
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GTK_TYPE_BUTTON) ? ((GtkButton*) _tmp16_) : NULL);
	_g_object_unref0 (self->priv->but_details);
	self->priv->but_details = _tmp17_;
	_tmp18_ = gtk_builder_get_object (builder, "txt_name");
	monitor_services_set_txt_name (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp18_) : NULL);
	_tmp19_ = self->priv->_txt_name;
	_tmp20_ = self->priv->name;
	gtk_entry_set_text (_tmp19_, _tmp20_);
	_tmp21_ = self->priv->_win_services;
	g_signal_connect_object ((GtkWidget*) _tmp21_, "destroy", (GCallback) _monitor_services_going_back_gtk_widget_destroy, self, 0);
	_tmp22_ = self->priv->tv_services;
	_tmp23_ = gtk_tree_view_get_selection (_tmp22_);
	_tmp24_ = _g_object_ref0 (_tmp23_);
	sel_services = _tmp24_;
	_tmp25_ = sel_services;
	gtk_tree_selection_set_mode (_tmp25_, GTK_SELECTION_SINGLE);
	_tmp26_ = sel_services;
	g_signal_connect_object (_tmp26_, "changed", (GCallback) ___lambda21__gtk_tree_selection_changed, self, 0);
	monitor_services_refresh (self);
	_g_object_unref0 (sel_services);
	_g_object_unref0 (builder);
	return self;
}


MonitorServices* monitor_services_new (NetsukukuAndnaPrivateConfiguration* root) {
	return monitor_services_construct (MONITOR_TYPE_SERVICES, root);
}


static void monitor_services_going_back (MonitorServices* self) {
	NetsukukuAndnaPrivateConfiguration* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->root;
	_tmp1_ = self->priv->_txt_name;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_tmp0_->domain);
	_tmp0_->domain = _tmp4_;
	g_signal_emit_by_name (self, "go-back");
}


void monitor_services_add_service_clicked (GtkButton* source, MonitorServices* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	monitor_services_add_service (self);
}


static void monitor_services_add_service (MonitorServices* self) {
	gchar* _tmp0_;
	gchar* serv_name;
	gchar* _tmp1_;
	gchar* serv_proto;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	NetsukukuAndnaServiceKey* _tmp4_;
	NetsukukuAndnaServiceKey* sk;
	NetsukukuAndnaPrivateConfiguration* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	NetsukukuAndnaServiceKey* _tmp8_;
	gboolean _tmp9_ = FALSE;
	NetsukukuAndnaPrivateConfiguration* _tmp10_;
	GeeHashMap* _tmp11_;
	GeeHashMap* _tmp12_;
	NetsukukuAndnaServiceKey* _tmp13_;
	GeeArrayList* _tmp14_ = NULL;
	GeeArrayList* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("undefined");
	serv_name = _tmp0_;
	_tmp1_ = g_strdup ("undefined");
	serv_proto = _tmp1_;
	_tmp2_ = serv_name;
	_tmp3_ = serv_proto;
	_tmp4_ = netsukuku_andna_service_key_new (_tmp2_, _tmp3_);
	sk = _tmp4_;
	_tmp5_ = self->priv->root;
	_tmp6_ = netsukuku_andna_private_configuration_get_services (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = sk;
	_tmp9_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp7_, _tmp8_);
	if (_tmp9_) {
		_g_object_unref0 (sk);
		_g_free0 (serv_proto);
		_g_free0 (serv_name);
		return;
	}
	_tmp10_ = self->priv->root;
	_tmp11_ = netsukuku_andna_private_configuration_get_services (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = sk;
	_tmp14_ = netsukuku_andna_private_configuration_server_make_null_list ();
	_tmp15_ = _tmp14_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp15_);
	_g_object_unref0 (_tmp15_);
	monitor_services_refresh (self);
	_g_object_unref0 (sk);
	_g_free0 (serv_proto);
	_g_free0 (serv_name);
}


void monitor_services_remove_service_clicked (GtkButton* source, MonitorServices* self) {
	NetsukukuAndnaPrivateConfiguration* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	NetsukukuAndnaServiceKey* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->root;
	_tmp1_ = netsukuku_andna_private_configuration_get_services (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->selected_key;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, _tmp3_, NULL);
	monitor_services_refresh (self);
}


static void _monitor_services_update_monitor_servers_go_back (MonitorServers* _sender, gpointer self) {
	monitor_services_update (self);
}


void monitor_services_details_service_clicked (GtkButton* source, MonitorServices* self) {
	NetsukukuAndnaPrivateConfiguration* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	NetsukukuAndnaServiceKey* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	MonitorServers* _tmp7_;
	MonitorServers* _tmp8_;
	GtkWindow* _tmp9_;
	GtkWindow* _tmp10_;
	GtkWindow* _tmp11_;
	GtkWindow* w;
	MonitorServers* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->root;
	_tmp1_ = netsukuku_andna_private_configuration_get_services (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->selected_key;
	_tmp4_ = self->priv->_txt_name;
	_tmp5_ = gtk_entry_get_text (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = monitor_servers_new (_tmp2_, _tmp3_, _tmp6_);
	_g_object_unref0 (self->priv->servers);
	self->priv->servers = _tmp7_;
	_tmp8_ = self->priv->servers;
	_tmp9_ = monitor_servers_get_win_servers (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	w = _tmp11_;
	gtk_window_set_title (w, "servers");
	gtk_widget_show_all ((GtkWidget*) w);
	gtk_window_set_position (w, GTK_WIN_POS_CENTER_ON_PARENT);
	_tmp12_ = self->priv->servers;
	g_signal_connect_object (_tmp12_, "go-back", (GCallback) _monitor_services_update_monitor_servers_go_back, self, 0);
	_g_object_unref0 (w);
}


void monitor_services_update (MonitorServices* self) {
	g_return_if_fail (self != NULL);
	monitor_services_refresh (self);
}


void monitor_services_refresh (MonitorServices* self) {
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->liststore_services;
	gtk_list_store_clear (_tmp0_);
	{
		NetsukukuAndnaPrivateConfiguration* _tmp1_;
		GeeHashMap* _tmp2_;
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _sk_it;
		_tmp1_ = self->priv->root;
		_tmp2_ = netsukuku_andna_private_configuration_get_services (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_abstract_map_get_keys ((GeeMap*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_sk_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			NetsukukuAndnaServiceKey* sk;
			GtkListStore* _tmp13_;
			GtkTreeIter _tmp14_ = {0};
			GtkListStore* _tmp15_;
			GtkTreeIter _tmp16_;
			NetsukukuAndnaServiceKey* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			GtkListStore* _tmp20_;
			GtkTreeIter _tmp21_;
			NetsukukuAndnaServiceKey* _tmp22_;
			_tmp9_ = _sk_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _sk_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			sk = (NetsukukuAndnaServiceKey*) _tmp12_;
			_tmp13_ = self->priv->liststore_services;
			gtk_list_store_append (_tmp13_, &_tmp14_);
			iter = _tmp14_;
			_tmp15_ = self->priv->liststore_services;
			_tmp16_ = iter;
			_tmp17_ = sk;
			_tmp18_ = netsukuku_andna_service_key_to_string (_tmp17_);
			_tmp19_ = _tmp18_;
			gtk_list_store_set (_tmp15_, &_tmp16_, MONITOR_LISTSERVICES_STR_REPR, _tmp19_, -1);
			_g_free0 (_tmp19_);
			_tmp20_ = self->priv->liststore_services;
			_tmp21_ = iter;
			_tmp22_ = sk;
			gtk_list_store_set (_tmp20_, &_tmp21_, MONITOR_LISTSERVICES_SERVICE_KEY, _tmp22_, -1);
			_g_object_unref0 (sk);
		}
		_g_object_unref0 (_sk_it);
	}
}


static void monitor_services_tv_services_selection_changed (MonitorServices* self) {
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	GtkTreeIter iter = {0};
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreeViewColumn* _tmp2_ = NULL;
	GtkTreePath* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tv_services;
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, &_tmp2_);
	_gtk_tree_path_free0 (path);
	path = _tmp1_;
	column = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ != NULL) {
		GtkListStore* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreeIter _tmp6_ = {0};
		gboolean _tmp7_ = FALSE;
		_tmp4_ = self->priv->liststore_services;
		_tmp5_ = path;
		_tmp7_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp4_, &_tmp6_, _tmp5_);
		iter = _tmp6_;
		if (_tmp7_) {
			GtkListStore* _tmp8_;
			GtkTreeIter _tmp9_;
			NetsukukuAndnaServiceKey* _tmp10_;
			NetsukukuAndnaServiceKey* _tmp11_;
			NetsukukuAndnaServiceKey* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GtkButton* _tmp16_;
			_tmp8_ = self->priv->liststore_services;
			_tmp9_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, MONITOR_LISTSERVICES_SERVICE_KEY, &self->priv->selected_key, -1);
			_tmp10_ = self->priv->selected_key;
			_tmp11_ = netsukuku_andna_service_key_get_NULL_SERV_KEY ();
			_tmp12_ = _tmp11_;
			_tmp13_ = netsukuku_andna_service_key_equal_func (_tmp10_, _tmp12_);
			if (!_tmp13_) {
				GtkButton* _tmp14_;
				_tmp14_ = self->priv->but_remove;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
			} else {
				GtkButton* _tmp15_;
				_tmp15_ = self->priv->but_remove;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
			}
			_tmp16_ = self->priv->but_details;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
		} else {
			GtkButton* _tmp17_;
			GtkButton* _tmp18_;
			_g_object_unref0 (self->priv->selected_key);
			self->priv->selected_key = NULL;
			_tmp17_ = self->priv->but_remove;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, FALSE);
			_tmp18_ = self->priv->but_details;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, FALSE);
		}
	} else {
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
		_g_object_unref0 (self->priv->selected_key);
		self->priv->selected_key = NULL;
		_tmp19_ = self->priv->but_remove;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
		_tmp20_ = self->priv->but_details;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, FALSE);
	}
	_gtk_tree_path_free0 (path);
}


GtkWindow* monitor_services_get_win_services (MonitorServices* self) {
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_win_services;
	result = _tmp0_;
	return result;
}


static void monitor_services_set_win_services (MonitorServices* self, GtkWindow* value) {
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_win_services);
	self->priv->_win_services = _tmp1_;
	g_object_notify ((GObject *) self, "win-services");
}


GtkWidget* monitor_services_get_widget_root (MonitorServices* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_widget_root;
	result = _tmp0_;
	return result;
}


static void monitor_services_set_widget_root (MonitorServices* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_widget_root);
	self->priv->_widget_root = _tmp1_;
	g_object_notify ((GObject *) self, "widget-root");
}


GtkEntry* monitor_services_get_txt_name (MonitorServices* self) {
	GtkEntry* result;
	GtkEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt_name;
	result = _tmp0_;
	return result;
}


static void monitor_services_set_txt_name (MonitorServices* self, GtkEntry* value) {
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_txt_name);
	self->priv->_txt_name = _tmp1_;
	g_object_notify ((GObject *) self, "txt-name");
}


static void monitor_services_class_init (MonitorServicesClass * klass) {
	monitor_services_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MonitorServicesPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_monitor_services_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_monitor_services_set_property;
	G_OBJECT_CLASS (klass)->finalize = monitor_services_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVICES_WIN_SERVICES, g_param_spec_object ("win-services", "win-services", "win-services", GTK_TYPE_WINDOW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVICES_WIDGET_ROOT, g_param_spec_object ("widget-root", "widget-root", "widget-root", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONITOR_SERVICES_TXT_NAME, g_param_spec_object ("txt-name", "txt-name", "txt-name", GTK_TYPE_ENTRY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("go_back", MONITOR_TYPE_SERVICES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void monitor_services_instance_init (MonitorServices * self) {
	self->priv = MONITOR_SERVICES_GET_PRIVATE (self);
}


static void monitor_services_finalize (GObject* obj) {
	MonitorServices * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MONITOR_TYPE_SERVICES, MonitorServices);
	_g_object_unref0 (self->priv->_win_services);
	_g_object_unref0 (self->priv->_widget_root);
	_g_object_unref0 (self->priv->root);
	_g_free0 (self->priv->name);
	_g_object_unref0 (self->priv->liststore_services);
	_g_object_unref0 (self->priv->tv_services);
	_g_object_unref0 (self->priv->but_add);
	_g_object_unref0 (self->priv->but_remove);
	_g_object_unref0 (self->priv->but_details);
	_g_object_unref0 (self->priv->_txt_name);
	_g_object_unref0 (self->priv->servers);
	_g_object_unref0 (self->priv->selected_key);
	G_OBJECT_CLASS (monitor_services_parent_class)->finalize (obj);
}


GType monitor_services_get_type (void) {
	static volatile gsize monitor_services_type_id__volatile = 0;
	if (g_once_init_enter (&monitor_services_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MonitorServicesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitor_services_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MonitorServices), 0, (GInstanceInitFunc) monitor_services_instance_init, NULL };
		GType monitor_services_type_id;
		monitor_services_type_id = g_type_register_static (G_TYPE_OBJECT, "MonitorServices", &g_define_type_info, 0);
		g_once_init_leave (&monitor_services_type_id__volatile, monitor_services_type_id);
	}
	return monitor_services_type_id__volatile;
}


static void _vala_monitor_services_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MonitorServices * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MONITOR_TYPE_SERVICES, MonitorServices);
	switch (property_id) {
		case MONITOR_SERVICES_WIN_SERVICES:
		g_value_set_object (value, monitor_services_get_win_services (self));
		break;
		case MONITOR_SERVICES_WIDGET_ROOT:
		g_value_set_object (value, monitor_services_get_widget_root (self));
		break;
		case MONITOR_SERVICES_TXT_NAME:
		g_value_set_object (value, monitor_services_get_txt_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_monitor_services_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MonitorServices * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MONITOR_TYPE_SERVICES, MonitorServices);
	switch (property_id) {
		case MONITOR_SERVICES_WIN_SERVICES:
		monitor_services_set_win_services (self, g_value_get_object (value));
		break;
		case MONITOR_SERVICES_WIDGET_ROOT:
		monitor_services_set_widget_root (self, g_value_get_object (value));
		break;
		case MONITOR_SERVICES_TXT_NAME:
		monitor_services_set_txt_name (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



